<script  lang="ts">
import { defineComponent } from 'vue'
import { useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag';
import { computed } from 'vue';


export default defineComponent({
     setup () {
    const { result, loading, error, refetch } = useQuery(gql`
      query getAllStudents {
          students {
          id
          sureName
          firstName
          middleName
          studentGroup
          year
        }
      }
    `)
     const students = computed(() => result.value?.students)

    return {
      students,
      loading,
      error,
      refetch,
    }
  }, 
})

</script>

<template>
  <div v-if="loading">Загрузка списка ...</div>
  <div v-else-if="error">Ошибка загрузки списка: {{ error.message }}</div>
  <ul v-else-if="students">
    <li v-for="student of students" :key="student.id">
      {{ student.sureName }} {{ student.firstName }} {{ student.middleName }} , группа:  {{ student.studentGroup }} курс [ {{ student.year }} ]
    </li>    
    <button  @click="refetch()">Обновить</button>
  </ul>
</template>
